﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using PropertyChanged;
using Xamarin.Forms;

namespace ControleCelular
{
	[ImplementPropertyChanged]
	public class CurrentAccountPageModel : BasePageModel
	{
		public string Test { get; set; }

		#region Column Width Properties
		public double DescriptionColumnWidth { get; set; }
		public double CreditColumnWidth { get; set; }
		public double DebitColumnWidth { get; set; }
		#endregion

		public ObservableCollection<CurrentAccountRecordModel> Records { get; set; }

		public CurrentAccountPageModel()
		{
			//TODO replace with live data
			var records = new List<CurrentAccountRecordModel>();
			records.Add(new CurrentAccountRecordModel { Description = "CAIXA INICIAL", Credit = 100 });
			records.Add(new CurrentAccountRecordModel { Description = "ATENDIMENTOS" });
			records.Add(new CurrentAccountRecordModel { Description = "Acessório", Credit = 250 });
			records.Add(new CurrentAccountRecordModel { Description = "Chip", Credit = 120 });
			records.Add(new CurrentAccountRecordModel { Description = "Recarga", Credit = 600 });
			records.Add(new CurrentAccountRecordModel { Description = "Celular", Credit = 1000 });
			records.Add(new CurrentAccountRecordModel { Description = "Outros" });
			records.Add(new CurrentAccountRecordModel { Description = "RECEBIMENTOS" });
			records.Add(new CurrentAccountRecordModel { Description = "ORDENS DE SERVIÇO", Credit = 100 });
			records.Add(new CurrentAccountRecordModel { Description = "OUTROS LANÇAMENTOS" });
			records.Add(new CurrentAccountRecordModel { Description = "Tele-moto", Debit = 10 });
			records.Add(new CurrentAccountRecordModel { Description = "Mercado", Debit = 10 });

			Records = new ObservableCollection<CurrentAccountRecordModel>(records);

			UpdateColumnsWidth();
		}

		public void UpdateColumnsWidth()
		{
			var screenService = DependencyService.Get<IScreenService>();

			Test = screenService.ScreenWidth > screenService.ScreenHeight ? "horizontal" : "vertical";

			var style = (Style)Application.Current.Resources["stackLayoutPagePadding"];
			var padding = ((Thickness)style.Setters[0].Value).HorizontalThickness;
			var screenWidth = screenService.ScreenWidth;

			var screenUsableWidth = screenWidth - padding;
			var columnWidth = screenUsableWidth / 3;

			DescriptionColumnWidth = columnWidth;
			CreditColumnWidth = columnWidth;
			DebitColumnWidth = columnWidth;
		}
	}
}
